package be.iminds.ilabt.jfed.restapi.json;

import be.iminds.ilabt.jfed.util.RFC3339Util;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;

import java.io.IOException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Date;

public class JsonTimeStampRFC3339Deserializer extends JsonDeserializer<Timestamp> {
    @Override
    public Timestamp deserialize(JsonParser jsonparser,
            DeserializationContext deserializationcontext) throws IOException, JsonProcessingException {
        String date = jsonparser.getText();
        try {
            Date resDate = RFC3339Util.rfc3339StringToDate(date);
            return new Timestamp(resDate.getTime());
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }

    }
}
